#include "StdAfx.h"
#include "TsData.h"
#include <time.h>

CTsData::CTsData(void)
{
	bEnd = FALSE;
	bDataUpdate = FALSE;
	LastSvcData = 0;
	DataFileVer = 0;
	memset(SvcData,0,sizeof(SvcData));
	memset(SecData,0,sizeof(SecData));
	PatList.clear();
	struct tm   *newTime;
	time_t      szClock;

	// Get time in seconds
	time( &szClock );

	// Convert time to struct tm form 
	newTime = localtime( &szClock );
	NowYear = newTime->tm_year+1900;
	NowMonth = newTime->tm_mon+1;
	NowDay = newTime->tm_mday;
	NowHour = newTime->tm_hour;
	NowMin = newTime->tm_min;
	NowSec = newTime->tm_sec;
}


CTsData::~CTsData(void)
{
	bEnd = TRUE;
	DataAllClear();
}

void CTsData::ConvDate(BYTE* pEpgDate,time_t* sTime,time_t* eTime)
{
	long year,month,day;
	Convert_mjd_to_date((pEpgDate[0]<<8)+pEpgDate[1],&year,&month,&day);
	int hour = (pEpgDate[2]>>4)*10+(pEpgDate[2]&0x0f);
	int min  = (pEpgDate[3]>>4)*10+(pEpgDate[3]&0x0f);
	int sec  = 0;//(pEpgDate[4]>>4)*10+(pEpgDate[4]&0x0f);
	int hourp = (pEpgDate[5]>>4)*10+(pEpgDate[5]&0x0f);
	int minp  = (pEpgDate[6]>>4)*10+(pEpgDate[6]&0x0f);
	int secp  = 0;//(pEpgDate[7]>>4)*10+(pEpgDate[7]&0x0f);
	// JnƏItime_tŎ擾
	struct tm etim;
	etim.tm_year = year-1900;
	etim.tm_mon =  month - 1;
	etim.tm_mday = day;
	etim.tm_hour = hour;
	etim.tm_min = min;
	etim.tm_sec = sec;
	*sTime = mktime(&etim);
	*eTime = *sTime + hourp*3600 + minp*60 + secp;
}

void CTsData::DataAllClear(BOOL bAll)
{
	for(int svc = 0;svc < SVC_MAX;svc++) {
		if(SvcData[svc]) {
			if(bAll) {
				delete SvcData[svc];
				SvcData[svc] = NULL;
			}
			else {
				//for(int section = 0;section < 512;section++) {
				//	int table = section < 256 ? 0:1;
				//	int sec = section >= 256 ? section-256:section;
				//	SvcData[svc]->EitSecData[table][sec].DeleteData();
				//	SvcData[svc]->EitSecDataEx[table][sec].DeleteData();
				//}
				SvcData[svc]->EitNowData[0].DeleteData();
			}
		}
	}
	for(int pid = 0;pid < 8192;pid++) {
		if(SecData[pid]) {
			delete SecData[pid];
			SecData[pid] = NULL;
		}
	}
}

void CTsData::ChangeChannel(void)
{
	for(int pid = 0;pid < 8192;pid++)
		if(SecData[pid])
			SecData[pid]->ResetData();
}

int CTsData::SearchSvcData(int ServiceId,BYTE NetworkId)
{
	int svc;
	for(svc = 0;svc < SVC_MAX;svc++) {
		if(!SvcData[svc]) {
			return -1;
		}
		if(SvcData[svc]->Service_id == ServiceId && GetNetId(SvcData[svc]->chNo) == NetworkId)
			return svc;
	}
	return -1;
}

int CTsData::GetSvcData(int ServiceId,BYTE NetworkId)
{
	int svc;
	char sztmp[256];
	for(svc = 0;svc < SVC_MAX;svc++) {
		if(!SvcData[svc]) {
			SvcData[svc] = new SVC_DATA;
			if(!SvcData[svc])
				svc = SVC_MAX;
			else {
				SvcData[svc]->Service_id = ServiceId;
				SvcData[svc]->chNo &= 0x0fff;
				SvcData[svc]->chNo |= NetworkId*4096;
				LastSvcData++;
				//wsprintf(sztmp,"Last add new serviceid=%d(%d)[%d] - %d\r\n",ServiceId,NetworkId,svc,LastSvcData);
				//OutputDebugString(sztmp);
			}
			break;
		}
		if(SvcData[svc]->Service_id == ServiceId && GetNetId(SvcData[svc]->chNo) == NetworkId)
			break;
		BOOL bIns = FALSE;
		if(GetNetId(SvcData[svc]->chNo) > NetworkId && LastSvcData < SVC_MAX)
			bIns = TRUE;
		if(GetNetId(SvcData[svc]->chNo) == NetworkId && SvcData[svc]->Service_id > ServiceId && LastSvcData < SVC_MAX)
			bIns = TRUE;
		if(bIns) {
			SvcData[LastSvcData] = new SVC_DATA;
			if(!SvcData[LastSvcData])
				svc = SVC_MAX;
			else {
				SVC_DATA* SvcDataTmp = SvcData[LastSvcData];
				for(int i = LastSvcData;i > svc ;i--)
					SvcData[i] = SvcData[i-1];
				SvcData[svc] = SvcDataTmp;
				SvcData[svc]->Service_id = ServiceId;
				SvcData[svc]->chNo &= 0x0fff;
				SvcData[svc]->chNo |= NetworkId*4096;
				LastSvcData++;
				//wsprintf(sztmp,"Insert add new serviceid=%d(%d)[%d] - %d\r\n",ServiceId,NetworkId,svc,LastSvcData);
				//OutputDebugString(sztmp);
				//for(int i = 0;i < SVC_MAX;i++) {
				//	if(!SvcData[i])
				//		break;
				//	wsprintf(sztmp,"%d:(%x) = %d\r\n",i,SvcData[i],SvcData[i]->Service_id);
				//	OutputDebugString(sztmp);
				//}
			}
			break;

		}
	}
	return svc;
}

void CTsData::DeleteSvcData(int ServiceId,BYTE NetworkId)
{
	if(LastSvcData == 0)
		return;
	// Sf[^NA
	if(ServiceId == 0) {
		for(int svc = 0;svc < SVC_MAX;svc++)
			if(SvcData[svc]) {
				delete SvcData[svc];
				 SvcData[svc] = NULL;
			}
		LastSvcData = 0;
	}
	else {
		for(int svc = 0;svc < SVC_MAX;svc++) {
			if(!SvcData[svc])
				break;
			if(SvcData[svc]->Service_id == ServiceId && GetNetId(SvcData[svc]->chNo) == NetworkId) {
				delete SvcData[svc];
				for(int i = svc;i < LastSvcData-1 ;i++)
					SvcData[i] = SvcData[i+1];
				LastSvcData--;
				SvcData[LastSvcData] = NULL;
				break;
			}
		}
	}
}

void CTsData::SetChannel(int ServiceID,int Channel)
{
	int svc = GetSvcData(ServiceID,0);
	// GǍAꍇ͐VK
	//for(svc = 0;svc < SVC_MAX;svc++) {
	//	if(!SvcData[svc]) {
	//		SvcData[svc] = new SVC_DATA;
	//		if(!SvcData[svc])
	//			svc = SVC_MAX;
	//		else
	//			SvcData[svc]->Service_id = ServiceID;
	//		break;
	//	}
	//	if(SvcData[svc]->Service_id == ServiceID)
	//		break;
	//}
	if(svc != SVC_MAX) {
		SvcData[svc]->chNo &= 0xf000;
		SvcData[svc]->chNo |= Channel;
	}
}

void CTsData::RecvTsPacket(BYTE* tsbuf)
{
	if(bEnd)
		return;
	TS_HEADER header;
	extract_ts_header(&header, tsbuf);
	BOOL bSecdump = FALSE;
	if(header.pid == 0x00 || header.pid == 0x12 || header.pid == 0x11 || header.pid == 0x10)
		bSecdump = TRUE;
	else {
		if(PatList.size() > 0) {
			vector<PAT_TABLE>::reference lastPat = PatList.back();
			vector<PAT_DATA>::iterator it = lastPat.patTable.begin();
			while(it != lastPat.patTable.end()) {
				if(header.pid == it->pmtPid) {
					bSecdump = TRUE;
					break;
				}
				else if(header.pid == it->vPid)
					it->vCount++;
				it++;
			}
		}
	}
	if(bSecdump)
		secdump(&header,tsbuf);
	else if(header.pid == 0x14 && tsbuf[5] == 0x73) {
		long year,month,day;
		Convert_mjd_to_date((tsbuf[8]<<8)+tsbuf[9],&year,&month,&day);
		NowYear = (int)year;
		NowMonth = (int)month;;
		NowDay = (int)day;
		NowHour = (tsbuf[10]>>4)*10+(tsbuf[10]&0x0f);
		NowMin  = (tsbuf[11]>>4)*10+(tsbuf[11]&0x0f);
		NowSec  = (tsbuf[12]>>4)*10+(tsbuf[12]&0x0f);
		struct tm etim;
		etim.tm_year = NowYear-1900;
		etim.tm_mon =  NowMonth - 1;
		etim.tm_mday = NowDay;
		etim.tm_hour = NowHour;
		etim.tm_min = NowMin;
		etim.tm_sec = NowSec;
		NowTime_t = mktime(&etim);
	}
}

void CTsData::secdump(TS_HEADER* ts,BYTE* buf)
{
	BYTE* sbuf = &buf[4];
	int sbuflen;

	if(!SecData[ts->pid]) {
		SecData[ts->pid] = new SEC_DATA;
		if(!SecData[ts->pid])
			return;
	}

	//BinaryDump(buf,16);
	if(SecData[ts->pid]->IsNext() && SecData[ts->pid]->nextcount == ts->continuity_counter) {
		int pos = 0;
		if(ts->payload_unit_start_indicator) {
			sbuflen = sbuf[0];
			pos = 1;
			//MsgOut("pPbgɎZNVf[^\n");
		}
		else
			sbuflen = 188 - 4;
		SecData[ts->pid]->AddData(&sbuf[pos],sbuflen);
		pidcheck(ts);
	}

	SecData[ts->pid]->SetNextCount(ts->continuity_counter);

	if(!ts->payload_unit_start_indicator)
		return;

	if(ts->adaptation_field_control&0x02)
		sbuf += (sbuf[0]+1);
	else if(ts->payload_unit_start_indicator)
		sbuf += (sbuf[0]+1);

	sbuflen = 188 - (int)(sbuf - buf);

	SecData[ts->pid]->ResetData();
	SecData[ts->pid]->AddData(sbuf,sbuflen);
	pidcheck(ts);
}

void CTsData::pidcheck(TS_HEADER* ts)
{
	if(SecData[ts->pid]->GetDataSize() > 3) {
		switch(ts->pid) {
			case 0x00:
				patdump(ts);
			case 0x10:
				nitdump(ts);
				break;
			case 0x11:
				sdtdump(ts);
				break;
			case 0x12:
				eitdump(ts);
				break;
			default:
				pmtdump(ts);
				break;
		}
	}
}

void CTsData::patdump(TS_HEADER* ts)
{
	BYTE* pSecData = SecData[ts->pid]->GetData();
	int secrcv = SecData[ts->pid]->GetDataSize();
	char tmp[256];

	int sec_length = ((pSecData[1]<<8)+pSecData[2]) & 0x0fff;
	if(sec_length <= secrcv) {
		DWORD crc = Calc_crc32(pSecData,sec_length+3);
		if(crc == 0) {
			if(pSecData[0] == 0x00) {
				WORD version = (pSecData[5]>>1) & 0x1f;
				if(!PatList.empty()) {
					if(version == PatList.back().patVersion)
						goto PATEND;
				}
				PAT_TABLE pattable;
				BYTE* pbuf = &pSecData[8];
				while(pbuf < &pSecData[sec_length+3-4]) {
					PAT_DATA patdata;
					patdata.Service_id = pbuf[0]*256+pbuf[1];
					patdata.pmtPid = (pbuf[2]&0x1f)*256+pbuf[3];
					if(patdata.Service_id > 0 && patdata.pmtPid != 0x1fc8)
						pattable.patTable.push_back(patdata);
					pbuf+=4;
				}
				pattable.patVersion = version;
				PatList.push_back(pattable);
			}
PATEND:
			SecData[ts->pid]->ResetData();
			if(sec_length+3 < secrcv) {
				if(pSecData[sec_length+3] != 0xff) {
					SecData[ts->pid]->AddData(&pSecData[sec_length+3],secrcv-(sec_length+3));
					pidcheck(ts);
				}
			}
		}
		else {
			SecData[ts->pid]->ResetData();
			//OutputDebugString("CRCG[\r\n");
		}
	}
}

void CTsData::pmtdump(TS_HEADER* ts)
{
	BYTE* pSecData = SecData[ts->pid]->GetData();
	int secrcv = SecData[ts->pid]->GetDataSize();
	char tmp[256];

	int sec_length = ((pSecData[1]<<8)+pSecData[2]) & 0x0fff;
	if(sec_length <= secrcv) {
		DWORD crc = Calc_crc32(pSecData,sec_length+3);
		if(crc == 0) {
			int vPid = 0;
			if(pSecData[0] == 0x02) {
				int flooplen = (pSecData[10]&0x0f) * 256 + pSecData[11];
				BYTE* slbuf = &pSecData[12+flooplen];
				while(slbuf < &pSecData[sec_length+3-4]) {
					if(slbuf[0] == 0x02) {
						vPid = (slbuf[1]&0x1f) * 256 + slbuf[2];
						break;
					}
					int slooplen = (slbuf[3]&0x0f) * 256 + slbuf[4];
					slbuf += (5+slooplen);
				}
				if(vPid != 0) {
					vector<PAT_TABLE>::reference lastPat = PatList.back();
					vector<PAT_DATA>::iterator it = lastPat.patTable.begin();
					while(it != lastPat.patTable.end()) {
						if(ts->pid == it->pmtPid) {
							it->vPid = vPid;
							break;
						}
						it++;
					}
				}
			}
			SecData[ts->pid]->ResetData();
			if(sec_length+3 < secrcv) {
				if(pSecData[sec_length+3] != 0xff) {
					SecData[ts->pid]->AddData(&pSecData[sec_length+3],secrcv-(sec_length+3));
					pidcheck(ts);
				}
			}
		}
		else {
			SecData[ts->pid]->ResetData();
			//OutputDebugString("CRCG[\r\n");
		}
	}
}

void CTsData::nitdump(TS_HEADER* ts)
{
	BYTE* pSecData = SecData[ts->pid]->GetData();
	int secrcv = SecData[ts->pid]->GetDataSize();
	char tmp[256];

	int sec_length = ((pSecData[1]<<8)+pSecData[2]) & 0x0fff;
	if(sec_length <= secrcv) {
		DWORD crc = Calc_crc32(pSecData,sec_length+3);
		if(crc == 0) {
			if(pSecData[0] == 0x40) {
				BYTE NetworkId = 0;
				int netid = ((pSecData[3]<<8)+pSecData[4]);
				if(netid >= 4 && netid <= 7)
					NetworkId = netid;
				//OutputDebugString("NIT\r\n");
				BYTE* sbuf = &pSecData[10];
				int slen = ((pSecData[8]<<8)+pSecData[9]) & 0x0fff;
				//while(sbuf < &pSecData[10+slen] && sbuf < &pSecData[sec_length+3-4]) {
				//	int dlen = sbuf[1];
				//	if(sbuf[0] == 0x40 && dlen > 0) {
				//		char sznetname[40];
				//		Convert_jpn_arib_char((char*)&sbuf[2],dlen,sznetname,40);
				//		//char sztmp[50];
				//		//wsprintf(sztmp,"Ntname = [%s]\r\n",sznetname);
				//		//OutputDebugString(sztmp);
				//		break;
				//	}
				//	sbuf += (2+dlen);
				//}
				BYTE* sbuf2 = &pSecData[12+slen];
				int slen2 = ((pSecData[10+slen]<<8)+pSecData[10+slen]) & 0x0fff;
				while(sbuf2 < &pSecData[12+slen+slen2] && sbuf2 < &pSecData[sec_length+3-4]) {
					int sbuf2len = ((sbuf2[4]<<8)+sbuf2[5]) & 0x0fff;
					BYTE* dbuf = &sbuf2[6];
					while(dbuf < &sbuf2[sbuf2len] && dbuf < &pSecData[sec_length+3-4]) {
						int dlen = dbuf[1];
						if(dbuf[0] == 0xcd) {
							char szname[40];
							int namelen = dbuf[3]>>2;
							int tcnt = dbuf[3]&0x03;
							int remno = dbuf[2];
							szname[0] = 0x00;
							if(namelen > 0)
								memcpy(szname,&dbuf[4],namelen);
							//if(namelen > 0)
							//	Convert_jpn_arib_char((char*)&dbuf[4],namelen,szname,40);
							//else
							//	szname[0] = 0x00;
							//char sztmp[1024],sztmp2[50];
							//wsprintf(sztmp,"Ch=%d,[%s]",dbuf[2],szname);
							BYTE* tbuf = &dbuf[4+namelen];
							for(int i = 0;i < tcnt;i++) {
								//wsprintf(sztmp2,",(%d",tbuf[0]);
								//strcat(sztmp,sztmp2);
								tbuf++;
								int svccnt = tbuf[0];
								tbuf++;
								for(int svc = 0;svc < svccnt;svc++) {
									int svcid = (tbuf[0]<<8) + tbuf[1];
									tbuf+=2;
									int svcno = SearchSvcData(svcid,NetworkId);
									if(svcno >= 0) {
										SvcData[svcno]->remoconNo = remno;
										SvcData[svcno]->szTsName[0] = 0x00;
										if(namelen > 0)
											memcpy(SvcData[svcno]->szTsName,szname,namelen);
										SvcData[svcno]->nTsNameLen = namelen;
									}
									//wsprintf(sztmp2,",%d",svcid);
									//strcat(sztmp,sztmp2);
								}
								//strcat(sztmp,")");
							}
							//strcat(sztmp,"\r\n");
							//OutputDebugString(sztmp);
							break;
						}
						dbuf += (2+dlen);
					}
					sbuf2 += sbuf2len;
				}
			}
			SecData[ts->pid]->ResetData();
			if(sec_length+3 < secrcv) {
				if(pSecData[sec_length+3] != 0xff) {
					SecData[ts->pid]->AddData(&pSecData[sec_length+3],secrcv-(sec_length+3));
					pidcheck(ts);
				}
			}
		}
		else {
			SecData[ts->pid]->ResetData();
			//OutputDebugString("CRCG[\r\n");
		}
	}
}

void CTsData::sdtdump(TS_HEADER* ts)
{
	BYTE* pSecData = SecData[ts->pid]->GetData();
	int secrcv = SecData[ts->pid]->GetDataSize();
	char tmp[256];

	int sec_length = ((pSecData[1]<<8)+pSecData[2]) & 0x0fff;
	if(sec_length <= secrcv) {
		DWORD crc = Calc_crc32(pSecData,sec_length+3);
		if(crc == 0) {
			if(pSecData[0] == 0x42) {
				BYTE NetworkId = 0;
				int netid = ((pSecData[8]<<8)+pSecData[9]);
				if(netid >= 4 && netid <= 7)
					NetworkId = netid;
				//OutputDebugString("STD\r\n");
				BYTE* sbuf = &pSecData[11];
				while(sbuf < &pSecData[sec_length+3-4]) {
					int service_id = (sbuf[0]<<8) + sbuf[1];
					BYTE* dbuf = &sbuf[5];
					int dlooplen = ((sbuf[3]<<8)+sbuf[4]) & 0x0fff;
					sbuf += (5+dlooplen);
					while(dbuf < sbuf && dbuf < &pSecData[sec_length+3-4]) {
						int dlen = dbuf[1];
						if(dbuf[0] == 0x48) {
							if(dbuf[2] == 0x01) {
								char szProviderName[50],szName[50];
								int nProviderNameLen = 0,nNameLen = 0;
								BYTE* pName = &dbuf[4];
								nProviderNameLen = dbuf[3];
								if(dbuf[3] > 0) {
									memcpy(szProviderName,&dbuf[4],dbuf[3]);
									pName += dbuf[3];
								}
								nNameLen = pName[0];
								if(pName[0] > 0) {
									memcpy(szName,&pName[1],pName[0]);
								}
								if(nNameLen > 0 || nProviderNameLen > 0) {
									int svc = GetSvcData(service_id,NetworkId);
									// GǍAꍇ͐VK
									//for(svc = 0;svc < SVC_MAX;svc++) {
									//	if(!SvcData[svc]) {
									//		//OutputDebugString("New SvcData\r\n");
									//		SvcData[svc] = new SVC_DATA;
									//		if(!SvcData[svc])
									//			svc = SVC_MAX;
									//		else
									//			SvcData[svc]->Service_id = service_id;
									//		break;
									//	}
									//	if(SvcData[svc]->Service_id == service_id)
									//		break;
									//}
									if(svc != SVC_MAX) {
										//wsprintf(tmp,"service = %d\r\n",service_id);
										//OutputDebugString(tmp);
										SvcData[svc]->nProviderNameLen = nProviderNameLen;
										if(nProviderNameLen > 0) {
											memcpy(SvcData[svc]->szProviderName,szProviderName,nProviderNameLen);
											//OutputDebugString("ProviderName\r\n");
										}
										SvcData[svc]->nNameLen = nNameLen;
										if(pName[0] > 0) {
											//OutputDebugString("Name\r\n");
											memcpy(SvcData[svc]->szName,szName,nNameLen);
										}
									}
								}
								break;
							}
						}
						dbuf += (2+dlen);
					}
				}
			}
			SecData[ts->pid]->ResetData();
			if(sec_length+3 < secrcv) {
				if(pSecData[sec_length+3] != 0xff) {
					SecData[ts->pid]->AddData(&pSecData[sec_length+3],secrcv-(sec_length+3));
					pidcheck(ts);
				}
			}
		}
		else {
			SecData[ts->pid]->ResetData();
			//OutputDebugString("CRCG[\r\n");
		}
	}
}

void CTsData::eitdump(TS_HEADER* ts)
{
	EIT_HEADER eit;
	BYTE* pSecData = SecData[ts->pid]->GetData();
	int secrcv = SecData[ts->pid]->GetDataSize();

	extract_eit_header(&eit,pSecData);
	if(eit.section_length+3 <= secrcv) {
		DWORD crc = Calc_crc32(pSecData,eit.section_length+3);
		//MsgOut("crc = %x\n",crc);
		if(crc == 0) {
			if(eit.table_id == 0x4e || eit.table_id == 0x4f) {
				BYTE NetworkId = 0;
				if(eit.original_network_id >= 4 && eit.original_network_id <= 7)
					NetworkId = eit.original_network_id;
				int svc = GetSvcData(eit.service_id,NetworkId);
				if(svc != SVC_MAX) {
					if(eit.section_length > 15) {
						EIT_SEC_DATA* pEitSecData = NULL;
						if(eit.table_id == 0x4e || eit.table_id == 0x4f) {
							if(eit.section_number == 0)
								pEitSecData = &SvcData[svc]->EitNowData[eit.section_number];
							//else
							//	OutputDebugString("0x4E ZNVNoُ\r\n");
						}
						if(pEitSecData) {
							if(pEitSecData->GetVersion() != eit.version_number) {
								pEitSecData->ver_cng_count++;
							}
							pEitSecData->SetData(pSecData,eit.section_length+3);
							if(PatList.size() > 0) {
								vector<PAT_TABLE>::reference lastPat = PatList.back();
								vector<PAT_DATA>::iterator it = lastPat.patTable.begin();
								while(it != lastPat.patTable.end()) {
									if(eit.service_id == it->Service_id) {
										if(it->nowEit.GetData() == 0)
											it->nowEit.Copy(pEitSecData);
										else {
											if(it->nowEit.GetVersion() != eit.version_number) {
												PAT_TABLE pattable;
												pattable.patVersion = lastPat.patVersion;
												pattable.patTable = lastPat.patTable;
												vector<PAT_DATA>::iterator pit = pattable.patTable.begin();
												while(pit != pattable.patTable.end()) {
													if(pit->Service_id == eit.service_id)
														pit->nowEit.Copy(pEitSecData);
													pit->vCount = 0;
													pit++;
												}
												PatList.push_back(pattable);
											}
										}
										break;
									}
									it++;
								}
							}
						}
					}
				}
			}
EITEND:
			SecData[ts->pid]->ResetData();
			if(eit.section_length+3 < secrcv) {
				if(pSecData[eit.section_length+3] != 0xff) {
					SecData[ts->pid]->AddData(&pSecData[eit.section_length+3],secrcv-(eit.section_length+3));
					pidcheck(ts);
				}
			}
		}
		else {
			SecData[ts->pid]->ResetData();
			//OutputDebugString("CRCG[\r\n");
		}
	}
}

void CTsData::extract_eit_header(EIT_HEADER *eit,unsigned char *buf)
{
	eit->table_id					= buf[0];
	eit->section_length				= ((buf[1]<<8) + buf[2]) & 0x0fff;
	eit->service_id					= ((buf[3]<<8) + buf[4]);
	eit->version_number				= (buf[5]>>1) & 0x1f;
	eit->current_next_indicator		= buf[5] & 0x01;
	eit->section_number				= buf[6];
	eit->last_section_number		= buf[7];
	eit->transport_stream_id		= ((buf[8]<<8) + buf[9]);
	eit->original_network_id		= ((buf[10]<<8) + buf[11]);
	eit->segment_last_section_number= buf[12];
	eit->last_table_id				= buf[13];
}

void CTsData::extract_ts_header(TS_HEADER *dst, unsigned char *packet)
{
	dst->sync                         =  packet[0];
	dst->transport_error_indicator    = (packet[1] >> 7) & 0x01;
	dst->payload_unit_start_indicator = (packet[1] >> 6) & 0x01;
	dst->transport_priority           = (packet[1] >> 5) & 0x01;
	dst->pid = ((packet[1] & 0x1f) << 8) | packet[2];
	dst->transport_scrambling_control = (packet[3] >> 6) & 0x03;
	dst->adaptation_field_control     = (packet[3] >> 4) & 0x03;
	dst->continuity_counter           =  packet[3]       & 0x0f;
}

unsigned long CTsData::Calc_crc32(unsigned char *start, size_t len)
{
	unsigned long crc=0xffffffff;
	size_t i;

	static const unsigned long table[256] = {
		0x00000000, 0x04C11DB7, 0x09823B6E, 0x0D4326D9,
		0x130476DC, 0x17C56B6B, 0x1A864DB2, 0x1E475005,
		0x2608EDB8, 0x22C9F00F, 0x2F8AD6D6, 0x2B4BCB61, 
		0x350C9B64, 0x31CD86D3, 0x3C8EA00A, 0x384FBDBD,
		
		0x4C11DB70, 0x48D0C6C7, 0x4593E01E, 0x4152FDA9,
		0x5F15ADAC, 0x5BD4B01B, 0x569796C2, 0x52568B75, 
		0x6A1936C8, 0x6ED82B7F, 0x639B0DA6, 0x675A1011,
		0x791D4014, 0x7DDC5DA3, 0x709F7B7A, 0x745E66CD,
		
		0x9823B6E0, 0x9CE2AB57, 0x91A18D8E, 0x95609039,
		0x8B27C03C, 0x8FE6DD8B, 0x82A5FB52, 0x8664E6E5,
		0xBE2B5B58, 0xBAEA46EF, 0xB7A96036, 0xB3687D81, 
		0xAD2F2D84, 0xA9EE3033, 0xA4AD16EA, 0xA06C0B5D,
		
		0xD4326D90, 0xD0F37027, 0xDDB056FE, 0xD9714B49,
		0xC7361B4C, 0xC3F706FB, 0xCEB42022, 0xCA753D95,
		0xF23A8028, 0xF6FB9D9F, 0xFBB8BB46, 0xFF79A6F1, 
		0xE13EF6F4, 0xE5FFEB43, 0xE8BCCD9A, 0xEC7DD02D,

		0x34867077, 0x30476DC0, 0x3D044B19, 0x39C556AE,
		0x278206AB, 0x23431B1C, 0x2E003DC5, 0x2AC12072, 
		0x128E9DCF, 0x164F8078, 0x1B0CA6A1, 0x1FCDBB16,
		0x018AEB13, 0x054BF6A4, 0x0808D07D, 0x0CC9CDCA,

		0x7897AB07, 0x7C56B6B0, 0x71159069, 0x75D48DDE, 
		0x6B93DDDB, 0x6F52C06C, 0x6211E6B5, 0x66D0FB02,
		0x5E9F46BF, 0x5A5E5B08, 0x571D7DD1, 0x53DC6066,
		0x4D9B3063, 0x495A2DD4, 0x44190B0D, 0x40D816BA,
		
		0xACA5C697, 0xA864DB20, 0xA527FDF9, 0xA1E6E04E,
		0xBFA1B04B, 0xBB60ADFC, 0xB6238B25, 0xB2E29692,
		0x8AAD2B2F, 0x8E6C3698, 0x832F1041, 0x87EE0DF6, 
		0x99A95DF3, 0x9D684044, 0x902B669D, 0x94EA7B2A,

		0xE0B41DE7, 0xE4750050, 0xE9362689, 0xEDF73B3E,
		0xF3B06B3B, 0xF771768C, 0xFA325055, 0xFEF34DE2, 
		0xC6BCF05F, 0xC27DEDE8, 0xCF3ECB31, 0xCBFFD686,
		0xD5B88683, 0xD1799B34, 0xDC3ABDED, 0xD8FBA05A,

		0x690CE0EE, 0x6DCDFD59, 0x608EDB80, 0x644FC637, 
		0x7A089632, 0x7EC98B85, 0x738AAD5C, 0x774BB0EB,
		0x4F040D56, 0x4BC510E1, 0x46863638, 0x42472B8F,
		0x5C007B8A, 0x58C1663D, 0x558240E4, 0x51435D53, 
		
		0x251D3B9E, 0x21DC2629, 0x2C9F00F0, 0x285E1D47,
		0x36194D42, 0x32D850F5, 0x3F9B762C, 0x3B5A6B9B,
		0x0315D626, 0x07D4CB91, 0x0A97ED48, 0x0E56F0FF,
		0x1011A0FA, 0x14D0BD4D, 0x19939B94, 0x1D528623,

		0xF12F560E, 0xF5EE4BB9, 0xF8AD6D60, 0xFC6C70D7,
		0xE22B20D2, 0xE6EA3D65, 0xEBA91BBC, 0xEF68060B, 
		0xD727BBB6, 0xD3E6A601, 0xDEA580D8, 0xDA649D6F,
		0xC423CD6A, 0xC0E2D0DD, 0xCDA1F604, 0xC960EBB3,
		
		0xBD3E8D7E, 0xB9FF90C9, 0xB4BCB610, 0xB07DABA7, 
		0xAE3AFBA2, 0xAAFBE615, 0xA7B8C0CC, 0xA379DD7B,
		0x9B3660C6, 0x9FF77D71, 0x92B45BA8, 0x9675461F,
		0x8832161A, 0x8CF30BAD, 0x81B02D74, 0x857130C3, 
		
		0x5D8A9099, 0x594B8D2E, 0x5408ABF7, 0x50C9B640,
		0x4E8EE645, 0x4A4FFBF2, 0x470CDD2B, 0x43CDC09C,
		0x7B827D21, 0x7F436096, 0x7200464F, 0x76C15BF8,
		0x68860BFD, 0x6C47164A, 0x61043093, 0x65C52D24,

		0x119B4BE9, 0x155A565E, 0x18197087, 0x1CD86D30,
		0x029F3D35, 0x065E2082, 0x0B1D065B, 0x0FDC1BEC,
		0x3793A651, 0x3352BBE6, 0x3E119D3F, 0x3AD08088,
		0x2497D08D, 0x2056CD3A, 0x2D15EBE3, 0x29D4F654,

		0xC5A92679, 0xC1683BCE, 0xCC2B1D17, 0xC8EA00A0,
		0xD6AD50A5, 0xD26C4D12, 0xDF2F6BCB, 0xDBEE767C,
		0xE3A1CBC1, 0xE760D676, 0xEA23F0AF, 0xEEE2ED18,
		0xF0A5BD1D, 0xF464A0AA, 0xF9278673, 0xFDE69BC4, 

		0x89B8FD09, 0x8D79E0BE, 0x803AC667, 0x84FBDBD0,
		0x9ABC8BD5, 0x9E7D9662, 0x933EB0BB, 0x97FFAD0C,
		0xAFB010B1, 0xAB710D06, 0xA6322BDF, 0xA2F33668, 
		0xBCB4666D, 0xB8757BDA, 0xB5365D03, 0xB1F740B4,
	};		
	for(i=0;i<len;i++)
	{
		crc=(crc<<8)^table[(crc>>24)^start[i]];
	}
	return crc;
}

void CTsData::tsread(const char *path,BOOL pCallBack(long readbyte,long totalbyte,HWND data),HWND indata)
{
	if(bEnd)
		return;
	int fd;

	int pid;
	int lcc;
	int i,m,n;
	int max_buff;
	int unit_size;

	TS_STATUS *stat;
	TS_HEADER  header;

	unsigned char *p;
	unsigned char *curr;
	unsigned char *tail;
	
	unsigned char buf[8192];

	fd = -1;
	stat = NULL;

	fd = _open(path, _O_BINARY|_O_RDONLY|_O_SEQUENTIAL);
	if(fd < 0){
		fprintf(stderr, "error - failed on open(%s) [src]\n", path);
		goto LAST;
	}

	__int64 readByte = 0;
	__int64 totalByte = _lseeki64(fd,0l,SEEK_END);
	_lseek(fd,0l,SEEK_SET);

	if(totalByte > 200*1024*1024) {
		readByte = 200*1024*1024;
		_lseek(fd,readByte,SEEK_SET);
	}
	if(totalByte > 500*1024*1024)
		totalByte = 500*1024*1024;

	if(pCallBack) {
		if(!pCallBack(0,totalByte/1000,indata))
			goto LAST;
	}

	n = _read(fd, buf, sizeof(buf));
	
	readByte += n;

	unit_size = select_unit_size(buf, buf+n);
	if(unit_size < 188){
		fprintf(stderr, "error - failed on select_unit_size()\n");
		goto LAST;
	}

	if(pCallBack) {
		if(!pCallBack(readByte/1000,totalByte/1000,indata))
			goto LAST;
	}

	do {
		curr = buf;
		tail = buf + n;
		while( (curr+unit_size) <= tail ){
			if(curr[0] != 0x47){
				p = resync(curr, tail, unit_size);
				if(p == NULL){
					break;
				}
				curr = p;
				if( (curr+unit_size) > tail ){
					break;
				}
			}
			extract_ts_header(&header, curr);
			pid = header.pid;
			RecvTsPacket(curr);
			curr += unit_size;
		}

		n = tail - curr;
		if(n > 0){
			memcpy(buf, curr, n);
		}
		m = _read(fd, buf+n, sizeof(buf)-n);

		if(m < 1){
			break;
		}
		n += m;
		readByte += m;
		if(readByte > totalByte) {
			readByte = totalByte;
		}
		if(pCallBack) {
			if(!pCallBack(readByte/1000,totalByte/1000,indata))
				goto LAST;
		}
		if(readByte >= totalByte) {
			goto LAST;
		}
	} while(n > unit_size);

	curr = buf;
	tail = buf + n;
	while( (curr+188) <= tail ){
		if(curr[0] != 0x47){
			p = resync_force(curr, tail, unit_size);
			if(p == NULL){
				break;
			}
			curr = p;
			if( (p+188) > tail ){
				break;
			}
		}
		extract_ts_header(&header, curr);
		pid = header.pid;
		RecvTsPacket(curr);
		curr += unit_size;
	}

LAST:

	if(pCallBack)
		pCallBack(totalByte/1000,totalByte/1000,indata);

	if(fd >= 0){
		_close(fd);
		fd = -1;
	}
}

int CTsData::select_unit_size(unsigned char *head, unsigned char *tail)
{
	int i;
	int m,n,w;
	int count[320];

	unsigned char *pre;
	unsigned char *buf;

	pre = NULL;
	buf = head;
	memset(count, 0, sizeof(count));

	// 1st step, find head 0x47
	while(buf < tail){
		if(buf[0] == 0x47){
			pre = buf;
			break;
		}
		buf += 1;
	}

	if(pre == NULL){
		return 0;
	}

	// 2nd step, count up 0x47 interval
	buf = pre + 1;
	while( buf < tail ){
		if(buf[0] == 0x47){
			m = buf - pre;
			if(m < 188){
				n = check_unit_invert(head, buf);
				if( (n >= 188) && (n < 320) ){
					count[n] += 1;
					pre = buf;
				}
			}else if(m < 320){
				count[m] += 1;
				pre = buf;
			}else{
				pre = buf;
			}
		}
		buf += 1;
	}

	// 3rd step, select maximum appeared interval
	m = 0;
	n = 0;
	for(i=188;i<320;i++){
		if(m < count[i]){
			m = count[i];
			n = i;
		}
	}

	// 4th step, verify unit_size
	w = m*n;
	if( (m < 8) || (w < ((tail-head) - (w/8))) ){
		return 0;
	}

	return n;
}

unsigned char *CTsData::resync(unsigned char *head, unsigned char *tail, int unit_size)
{
	int i;
	unsigned char *buf;

	buf = head;
	tail -= unit_size * 8;
	while( buf < tail ){
		if(buf[0] == 0x47){
			for(i=1;i<8;i++){
				if(buf[unit_size*i] != 0x47){
					break;
				}
			}
			if(i == 8){
				return buf;
			}
		}
		buf += 1;
	}

	return NULL;
}

unsigned char *CTsData::resync_force(unsigned char *head, unsigned char *tail, int unit_size)
{
	int i,n;
	unsigned char *buf;

	buf = head;
	while( buf < (tail-188) ){
		if(buf[0] == 0x47){
			n = (tail - buf) / unit_size;
			if(n == 0){
				return buf;
			}
			for(i=1;i<n;i++){
				if(buf[unit_size*i] != 0x47){
					break;
				}
			}
			if(i == n){
				return buf;
			}
		}
		buf += 1;
	}

	return NULL;
}

int CTsData::check_unit_invert(unsigned char *head, unsigned char *tail)
{
	unsigned char *buf;
	
	buf = tail-188;

	while(head <= buf){
		if(buf[0] == 0x47){
			return tail-buf;
		}
		buf -= 1;
	}

	return 0;
}
